#!tclsh
# Check txrx for memory leaks. See top of txrxTest.test for
# a more detailed description.
# SCCS: @(#) txrxChkM.tcl 1.1 96/08/13 15:18:54

# Run this script only when Tcl has been compiled with -DTCL_MEM_DEBUG.
history keep 1
catch "lappend auto_path . .. ./txrx"
catch "package require txrx"
if [catch "txrx list"] {
    puts "Package txrx is not loaded"
    exit 1
}

source defs 
source txrxTest.test
if [catch "memory validate on"] {
    puts "Tcl has not been compiled with -DTCL_MEM_DEBUG"
    exit 1
}
memory active txrx_temp.m0
source txrxTest.test
memory active txrx_temp.m1

# Only works on UNIX machines.
catch "exec diff txrx_temp.m0 txrx_temp.m1" res
puts stdout $res
exit 0


